import ssl
import json
import arcpy
import os
from JsonRouteParameters import RouteParameter
import dateutil.parser
import uuid
import random
import json
import os
import urllib.parse
import urllib.request
import pytz
import certifi
import logging
import sys
import logging
from log import ArcPyLogHandler

sr = arcpy.SpatialReference(4326)
arrival = None
departure = None
location = None
wgs = arcpy.SpatialReference(4326)
parameters = arcpy.GetParameterInfo()
transpotations = {};
scriptPath = sys.argv[0]
toolSharePath = os.path.dirname(os.path.dirname(scriptPath))
dataPath = os.path.join(toolSharePath, 'iGeolise')
queryCount = 0
robustMode = False
parametersList = list()
requestlist = list()
routesFailed = 0

for params in parameters:
    parametersList.append(str(params.value).split(";")) 

advParaList = ['','Name','UTC','departure','','public_transport','','Name','','','0', '15', '30', '15', '5', '0', '0','','']
simpleParaList = ['','public_transport','UTC','departure','','','']


if len(parametersList[0]) == 8 :
    paramlist = list()
    count = len(parametersList[0])
    for x in range(count):
        objectlist = list()
        for idx, data in enumerate(parametersList):
            if x < len(data): 
                 objectlist.append(data[x])
            else:
                objectlist.append(simpleParaList[idx])
        paramlist.append(objectlist)
else:
    paramlist = list()
    count = len(parametersList[0])
    for x in range(count):
        objectlist = list()
        for idx, data in enumerate(parametersList):
            if x < len(data): 
                 objectlist.append(data[x])
            else:
                objectlist.append(advParaList[idx])
        paramlist.append(objectlist)



res = paramlist

arcpy.AddMessage("Processing algorithm…") 
arcpy.AddMessage("Algorithm 'Routes - Simple' starting…") 
arcpy.AddMessage("Input parameters: {}".format(res)) 
arcpy.AddMessage("TravelTime Plugin Version : 3.0.7")
arcpy.AddMessage("TravelTime Algorithm : RouteAlgorithm")

try:
    # Create logger
    logger = logging.getLogger()
    #logger.setLevel(logging.INFO)
    # Create STDERR handler
    #handler = logging.StreamHandler(sys.stderr)
    logFilePath = os.path.join(toolSharePath, 'TraveltimeLog.log')
    arcpy.AddMessage(logFilePath)
    handler = ArcPyLogHandler(
    logFilePath,
    maxBytes=1024 * 1024 * 200, #2MB log files
    backupCount=10
)
    formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')
    handler.setFormatter(formatter)
    logger.handlers = []
    logger.addHandler(handler)
    logger.setLevel(logging.DEBUG)

except Exception:
    e = sys.exc_info()[1]
    logger.error('An error occurred: {}'.format(e.args[0]))
      
def loadJson(jsonResponse,feature):		
    jsonResult = jsonResponse 
    
    try:
        i = 0; 
        for Jresults in jsonResult['results']:            
            search_id = Jresults['search_id'].split('-')                
            for loc in Jresults['locations']:    
                if Output_style.replace("'","") != "By transport type" :
                    coord = list()
                totalTime = 0
                totalDistance = 0
                for parts in loc['properties'][0]['route']['parts']:
                    if Output_style.replace("'","") == "By transport type" :
                        coord = list()
                    for geom in parts['coords']:
                        geometry = [geom['lng'],geom['lat']]
                        coord.append(geometry)
                    totalTime += int(parts['travel_time'])
                    totalDistance +=  parts['distance']
                    try:
                        if Output_style.replace("'","") == "By transport type" :
                            if search_type == "departure":
                                feature.append({"type": "Feature","id":"destination","geometry": {"type": "LineString","coordinates":coord},"properties": {"FID": i,"id": parts['id'],"type": parts['type'],"mode": parts['mode'],"directions": parts['directions'],"direction": None,"travel_time": parts['travel_time'],"location_id":search_id[0],"search_id":loc['id'],"turn":None,"distance": parts['distance'] }})
                            else :
                                feature.append({"type": "Feature","id":"destination","geometry": {"type": "LineString","coordinates":coord},"properties": {"FID": i,"id": parts['id'],"type": parts['type'],"mode": parts['mode'],"directions": parts['directions'],"direction": None,"travel_time": parts['travel_time'],"location_id":loc['id'],"search_id":search_id[0],"turn":None,"distance": parts['distance'] }})                    

                            #feature.append({"type": "Feature","id":"destination","geometry": {"type": "LineString","coordinates":coord},"properties": {"FID": i,"id": parts['id'],"type": parts['type'],"mode": parts['mode'],"directions": parts['directions'],"direction": None,"travel_time": parts['travel_time'],"location_id":search_id[0],"search_id":loc['id'],"turn":None,"distance": parts['distance'] }})                    

                            i=i+1
                    except:
                        #i=i+1
                        arcpy.AddMessage("geometry is empty.")
                try:
                    if Output_style.replace("'","") != "By transport type":
                        if search_type == "departure":
                            feature.append({"type": "Feature","id":"destination","geometry": {"type": "LineString","coordinates":coord},"properties": {"FID": i,"id": parts['id'],"location_id":search_id[0],"search_id":loc['id'],"travel_time": totalTime,"turn":None,"distance":totalDistance,"Label":"from "+search_id[0]+" to "+loc['id']}})
                        else :
                            feature.append({"type": "Feature","id":"destination","geometry": {"type": "LineString","coordinates":coord},"properties": {"FID": i,"id": parts['id'],"location_id":loc['id'],"search_id":search_id[0],"travel_time": totalTime,"turn":None,"distance":totalDistance,"Label":"From "+loc['id']+" to "+search_id[0]}})
                        i=i+1
                except :
                    arcpy.AddMessage("geometry is empty.")
        return feature
    except KeyError:        
        arcpy.AddWarning("Error {}".format(jsonResult))
        return feature

def parseRequest(requestParameter,APP_ID,API_KEY,Output_style,customize_endpoint):                  
    API_ENDPOINT = customize_endpoint+"/v4/routes"
    headers = {
        'Accept': "application/json",
        'X-Application-Id': APP_ID,
        'X-Api-Key': API_KEY,
        'Content-Type': "application/json",
        'User-Agent' : "ArcGIS Pro v3.0"
        }
    feature = list()
    featureCollection = list()
    for request in requestParameter: 

         try :               
                req = urllib.request.Request(API_ENDPOINT, json.dumps(request).encode('utf-8'), headers = headers)
                context = ssl.create_default_context(cafile=certifi.where())
                res = json.loads(urllib.request.urlopen(req, context=context).read().decode('utf-8'))     
         except urllib.error.URLError as e:
             routesFailed += 1
             API_RESPONSE = e.file
             data = json.load(API_RESPONSE)
             arcpy.AddWarning('An error occurred: {}'.format(data))
             continue

         try:
            loadJson(res,feature)
         except Exception:
            routesFailed += 1
            API_RESPONSE = e.file
            data = json.load(API_RESPONSE)
            arcpy.AddWarning(format(data))
            continue

    if len(feature) == 0:
        arcpy.AddError("no routes to display")
        exit(0)

    featureCollection.append({"type":"FeatureCollection","features": feature}) 
    outputFilePath =  os.path.join(dataPath, 'output.json')
    with open(outputFilePath,'w+') as f:	
        json.dump(featureCollection[0], f)  	
    
    try:       
        arcpy.env.overwriteOutput = True
        arcpy.env.addOutputsToMap = False
        arcpy.JSONToFeatures_conversion(outputFilePath,Output_layer ,'POLYLINE')
        getRendering(outputFilePath,Output_layer,Output_style)
        layerName = (arcpy.Describe(Output_layer)).baseName
        if len(parameters) > 8:
            arcpy.JoinField_management( layerName, "location_id", departure_search,"LocationID",parametersList[17] )
            arcpy.JoinField_management( layerName, "search_id", location_search,"searchesID",parametersList[18] )
    except Exception as ex:
        arcpy.AddWarning('An error occurred: ' + str(ex))
      

def unique(list1):
  
    # intilize a null list 
    unique_list = [] 
      
    # traverse for all elements 
    for x in list1: 
        # check if exists in unique_list or not 
        if x not in unique_list and x != 0: 
            unique_list.append(x)
    return unique_list

def getRendering(outputFilePath,Output_layer,Output_style):
    try:
        
        if Output_style.replace("'","") == "By journey" : 
            layerName = (arcpy.Describe(Output_layer)).baseName
            p = arcpy.mp.ArcGISProject('CURRENT')
            m = p.listMaps('Map')[0]        
            m.addDataFromPath(Output_layer)
            lyr = m.listLayers(layerName)
            for l in lyr:                    
                if l.name == layerName :                    
                    sym = l.symbology
                    sym.updateRenderer('UniqueValueRenderer')
                    sym.renderer.fields = ['Label']            
                    for grp in sym.renderer.groups:
                        for itm in grp.items:
                            itm.label #Grab the first "percent" value in the list of potential values
                            itm.symbol.color = getRGB()
                            itm.symbol.size = 2 
                            
                l.symbology = sym
                time.sleep(5)                
                             
        elif Output_style.replace("'","") == "By transport type" :                   
            TransportPolyLineLyrPath = os.path.join(dataPath, 'DetailedRouteSymbols.lyrx')
            Transportparams = arcpy.GetParameterInfo()
            Transportparams[symbol_index].symbology = TransportPolyLineLyrPath            
                    
            time.sleep(5) 

        elif Output_style.replace("'","") == "By travel time" :
            arcpy.JSONToFeatures_conversion(outputFilePath,Output_layer ,'POLYLINE')
            layerName = (arcpy.Describe(Output_layer)).baseName
            p = arcpy.mp.ArcGISProject('CURRENT')
            m = p.listMaps('Map')[0]        
            m.addDataFromPath(Output_layer)
            lyr = m.listLayers(layerName)
            for l in lyr:                    
                 if l.name == layerName :
                    classBreakValues = [5.0,15.0,30.0,60.0,120.0,300.0,14400]
                    classBreakLowerValues = [0, 5, 15, 30, 60, 120, 300]
                    classBreakLabels = ["0-5 min", "5-15 min", "15-30 min", "30-60 min", "1-2 hrs","2-5 hrs",">5 hrs"]
                    classBreakLColor = [{'RGB': [255, 238, 5, 100]}, {'RGB': [255, 159, 5, 100]}, {'RGB': [255, 93, 5, 100]}, {'RGB': [245, 5, 5, 100]}, {'RGB': [204, 0, 0, 100]}, {'RGB': [168, 0, 20, 100]}, {'RGB': [87, 0, 64, 100]}]
                    sym = l.symbology
                    if sym.renderer.type == 'SimpleRenderer':
                        sym.updateRenderer('GraduatedColorsRenderer')
                        sym.renderer.breakCount = len(classBreakValues)
                        sym.renderer.classificationField = 'travel_time'
                        sym.renderer.nomalizationType  = '<None>'
                        sym.renderer.numClasses  = '7'
                        idxlist = list()
                        for brk in sym.renderer.classBreaks:
                            
                            breakval = round(float(brk.label.split("-")[1]))
                            idx = classBreakLowerValues.index(classBreakLowerValues [min(range(len(classBreakLowerValues )), key = lambda i: abs(classBreakLowerValues [i]-breakval))])
                            idxlist.append(idx)
                        sym.renderer.breakCount  = len(unique(idxlist))
                        uniquelist = unique(idxlist)
                        count = 0
                        for brk in sym.renderer.classBreaks:
                            breakval = round(float(brk.label.split("-")[1]))
                            idx = classBreakLowerValues.index(classBreakLowerValues [min(range(len(classBreakLowerValues )), key = lambda i: abs(classBreakLowerValues [i]-breakval))])
                            brk.upperBound = classBreakValues[uniquelist[count]]
                            brk.label = classBreakLabels[uniquelist[count]]
                            brk.symbol.color = classBreakLColor[uniquelist[count]]
                            count += 1
                    l.symbology = sym
                   
            time.sleep(5) 
    except Exception:
        e = sys.exc_info()[1]

def getRGB():
    red = random.randint(0,255)
    g = random.randint(0,255)
    b = random.randint(0,255)
    a = random.randint(200,255)
    return  {'RGB':  [red,g, b, a]} 


for para in res:
    if len(parameters) == 8 :
        departure_search = para[0].replace("'","")
        search_type = para[3].replace("'","")  
        Transportation_type = para[1].replace("'","")
        Time_zone = para[2].replace("'","")
        Date_time = dateutil.parser.parse(para[4].replace("'",""))    
        location_search = para[5].replace("'","")  
        Output_style = para[6].replace("'","")
        Output_layer = para[7].replace("'","")
        transpotations["type"] = Transportation_type
        symbol_index = 7
        Search_range_width = 1800
    else :
        departure_search = para[0].replace("'","")
        Departure_ID = para[1].replace("'","")
        search_type = para[3].replace("'","")   
        Time_zone = para[2].replace("'","")
        Date_time = dateutil.parser.parse(para[4].replace("'",""))    
        Transportation_type = para[5].replace("'","")   
        location_search = para[6].replace("'","")  
        location_id = para[7].replace("'","")  
        Output_style = para[8].replace("'","")
        Output_layer = para[9].replace("'","")
        change_delay = para[10].replace("'","")
        walking_time= para[11].replace("'","")
        driving_time_to_station= para[12].replace("'","")
        cycling_time_to_station= para[13].replace("'","")
        parking_time= para[14].replace("'","")
        boarding_time= para[15].replace("'","")
        Search_range_width= int(para[16].replace("'",""))*60
        Fields_To_KeepD = para[17].replace("'","")
        Fields_To_KeepA = para[18].replace("'","")

        transpotations["type"] = Transportation_type
        transpotations["pt_change_delay"] = int(change_delay)*60
        transpotations["walking_time"] = int(walking_time)*60
        transpotations["driving_time_to_station"] = int(driving_time_to_station)*60
        transpotations["cycling_time_to_station"] = int(cycling_time_to_station)*60
        transpotations["parking_time"] = int(parking_time)*60
        transpotations["boarding_time"] = int(boarding_time)*60
        #transpotations["Search_range_width"] = int(Search_range_width)*60
        symbol_index = 9

    #tzinfo = arcpy.time.TimeZoneInfo(Time_zone) 
    #travel_time= Date_time.astimezone(tzinfo)    
    tzinfo = pytz.timezone(Time_zone)    
    travel_time = (tzinfo.localize(Date_time)).isoformat()

    arcpy.env.overwriteOutput = True
    arcpy.env.addOutputsToMap = False
    Req = list ()
    departure_id =list()
    arrival_ids =list()
    arrival_ids_chunk =list()
    departure_searches = list()
    arrival_searches = list()
   
    authenticatoinFilePath =  os.path.join(toolSharePath, 'Authentication.json') # "..//Authentication.json"
   
    try:
        with open(authenticatoinFilePath) as f:
          data = json.load(f)          
          if  '' in [data['Api_key'], data['App_id']]:
              arcpy.AddError("Error: You need a TravelTime platform API key to make requests. Please head to https://docs.traveltime.com/arcgis/sign-up to obtain one, and enter it in the plugin's setting dialog.")
              exit(0)
          else:
            APP_ID =  data['App_id']
            API_KEY = data['Api_key']
            customize_endpoint = data['customize_endpoint']
           
            arrival_ids =list()
            Source = list()
            ApiCount = 0
            prop = list(["travel_time", "distance", "route"])
            locations = list()
            ### arrival locations

            for row in arcpy.da.SearchCursor(location_search, ["OID@", "SHAPE@"]):        
                pnt_wgs = row[1].projectAs(wgs)
                id_search = "searches" + str(row[0])
                arrival_ids.append("searches" + str(row[0]))                
                locations.append({"id":id_search,"coords" : { "lng" : pnt_wgs.centroid.X, "lat":pnt_wgs.centroid.Y}})
 
            n=1
            m=20
            final = [locations[i * m:(i + 1) * m] for i in range((len(locations) + m - 1) // m )]  
            arrival_ids_chunk = [arrival_ids[i * n:(i + 1) * n] for i in range((len(arrival_ids) + n - 1) // n )]              
            reuest_list = list()
            if len(parameters) > 9:
                arcpy.AddField_management(location_search, "searchesID", "TEXT" )
                fields = arcpy.ListFields(location_search)
                if fields[0].name == "FID":
                    arcpy.CalculateField_management(location_search, "searchesID","'searches'+str(!FID!)", "Python 3")
                else:
                    arcpy.CalculateField_management(location_search, "searchesID","'searches'+str(!OBJECTID!)", "Python 3")
            
            departure_search_list = list()
            departureList = list()
            departure_ids =list()
            for row in arcpy.da.SearchCursor(departure_search, ["OID@", "SHAPE@"]):                     
                departure_search_id = "Location" + str(row[0])  
                departure_ids.append(departure_search_id)
                pnt_wgs = row[1].projectAs(wgs)                
                departureList.append({"id":departure_search_id,"coords" : { "lng" : pnt_wgs.centroid.X, "lat":pnt_wgs.centroid.Y}})
                locations.append({"id":departure_search_id,"coords" : { "lng" : pnt_wgs.centroid.X, "lat":pnt_wgs.centroid.Y}})
                                      
            n=1
            m=20
            dfinal = [departureList[i * m:(i + 1) * m] for i in range((len(departureList) + m - 1) // m )]  
            departure_ids_chunk = [departure_ids[i * n:(i + 1) * n] for i in range((len(departure_ids) + n - 1) // n )]
            
            if len(parameters) > 9:
                arcpy.AddField_management(departure_search, "LocationID", "TEXT" )
                fields = arcpy.ListFields(departure_search)
                if fields[0].name == "FID":
                    arcpy.CalculateField_management(departure_search, "LocationID","'Location'+str(!FID!)", "Python 3")
                else:
                    arcpy.CalculateField_management(departure_search, "LocationID","'Location'+str(!OBJECTID!)", "Python 3")

            if search_type == "departure":
                reuest_list = list()
                for departure_id in departure_ids:
                    for i in range(len(arrival_ids_chunk)):   
                            if Search_range_width == 0:
                                departure_searches.append({"id":departure_id+"-"+ str(uuid.uuid1()),"departure_location_id":departure_id,"arrival_location_ids":arrival_ids_chunk[i],"transportation":transpotations,"departure_time":travel_time,"properties":prop })
                            else:
                                departure_searches.append({"id":departure_id+"-"+ str(uuid.uuid1()),"departure_location_id":departure_id,"arrival_location_ids":arrival_ids_chunk[i],"transportation":transpotations,"departure_time":travel_time,"properties":prop,"range": {"enabled": True, "max_results": 5,"width": Search_range_width}  })

            else:
                for arrival_id in arrival_ids:
                     for i in range(len(departure_ids_chunk)): 
                         if Search_range_width == 0:
                             departure_searches.append({"id":arrival_id+"-"+ str(uuid.uuid1()),"departure_location_ids":departure_ids_chunk[i],"arrival_location_id":arrival_id,"transportation": transpotations,"arrival_time":travel_time,"properties":prop, })
                         else:
                             departure_searches.append({"id":arrival_id+"-"+ str(uuid.uuid1()),"departure_location_ids":departure_ids_chunk[i],"arrival_location_id":arrival_id,"transportation": transpotations,"arrival_time":travel_time,"properties":prop,"range": {"enabled": True, "max_results": 5,"width": Search_range_width} })

            for request in departure_searches:
                arcpy.AddMessage("--- " + json.dumps(request))

            d=1        
            departure_searches_chunk = [departure_searches[i * d:(i + 1) * d] for i in range((len(departure_searches) + d - 1) // d )] 
    
            for departure_search in departure_searches_chunk:
                if search_type == "departure":
                    req = RouteParameter(locations,departure_search,None)
                else:
                    req = RouteParameter(locations,None,departure_search)
                departure_search_list.append(req.__dict__)
                ApiCount = ApiCount + 1
                
            arcpy.AddMessage("The search will perform "+str(ApiCount)+" API calls. Keep an eye on your API usage.")

            parseRequest(departure_search_list,APP_ID,API_KEY,Output_style,customize_endpoint)  

            arcpy.management.AlterField(Output_layer,'travel_time','travel_time','travel time (seconds)');
            arcpy.management.AlterField(Output_layer,"distance","distance","distance (meters)");
   
    except Exception:
        e = sys.exc_info()[1]
        arcpy.AddError(e)
        pass

    if routesFailed > 0:
        arcpy.AddWarning(str(routesFailed) + " of total " + str(len(departure_search_list)) + " routes failed")