import requests
import json
import collections
import arcpy
import os
import ssl
from JsonParameters import RootObject
from JsonRouteParameters import RouteParameter
from jsonResponse import ResponseParameters
from TimeMapRequest import TimeMapParams
import dateutil.parser
import datetime
import uuid
import locale
import json
import urllib.parse
import urllib.request
import pytz
import certifi
import sys
import logMessage
import requests
import logging
import http.client
from log import ArcPyLogHandler

APP_ID = "d8e9df9d"
API_KEY = "8a062f21f574e7918700ff2feba8fa98"
cur_locale = locale.getlocale()
locale.setlocale(locale.LC_TIME, cur_locale)

sr = arcpy.SpatialReference(4326)

arrival_searches = None
data =  {
  "departure_searches": [],
  "arival_searches": []
  }

wgs = arcpy.SpatialReference(4326)
parameters = arcpy.GetParameterInfo()
transpotations = {};

scriptPath = sys.argv[0]
toolSharePath = os.path.dirname(os.path.dirname(scriptPath))
dataPath = os.path.join(toolSharePath, 'iGeolise')



parametersList = list()
requestlist = list()
for params in parameters:
    parametersList.append(str(params.value).split(";"))



advParaList = ['','name','UTC','departure','','public_transport','15','NORMAL','','0', '15', '30', '15', '5', '0', '0','0']
simpleParaList = ['','public_transport','UTC','departure','','15','NORMAL','']


if len(parametersList[0]) == 8:
    paramlist = list()
    count = len(parametersList[0])
    for x in range(count):
        objectlist = list()
        for idx, data in enumerate(parametersList):
            if x < len(data): 
                 objectlist.append(data[x])
            else:
                objectlist.append(simpleParaList[idx])
        paramlist.append(objectlist)
else:
    paramlist = list()
    count = len(parametersList[0])
    for x in range(count):
        objectlist = list()
        for idx, data in enumerate(parametersList):
            if x < len(data): 
                 objectlist.append(data[x])
            else:
                objectlist.append(advParaList[idx])
        paramlist.append(objectlist)



res =  paramlist

arcpy.AddMessage("Processing algorithm…") 
arcpy.AddMessage("Input parameters: {}".format(res)) 
arcpy.AddMessage("TravelTime Plugin Version : 3.0.7")
arcpy.AddMessage("TravelTime Algorithm : TimeMapAlgorithm")

try:
    # Create logger
    logger = logging.getLogger()
    #logger.setLevel(logging.INFO)
    # Create STDERR handler
    #handler = logging.StreamHandler(sys.stderr)
    logFilePath = os.path.join(toolSharePath, 'TraveltimeLog.log')
    arcpy.AddMessage(logFilePath)
    handler = ArcPyLogHandler(
    logFilePath,
    maxBytes=1024 * 1024 * 200, #2MB log files
    backupCount=10
)
    formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')
    handler.setFormatter(formatter)
    logger.handlers = []
    logger.addHandler(handler)
    logger.setLevel(logging.DEBUG)

except Exception:
    e = sys.exc_info()[1]
    logger.error('An error occurred: {}'.format(e.args[0]))
  



## generzte parameter
for para in res:    
    if len(para) == 8 :
        departure_search = para[0].replace("'","")
        search_type = para[3].replace("'","")
        Time_zone = para[2].replace("'","")
        Date_time = dateutil.parser.parse(para[4].replace("'",""))    
        Transportation_type = para[1].replace("'","")
        
        if int(para[5]) > 240:
            arcpy.AddError("Travel time should be less than or equal to 240 mins , please try again with different time")
        else:
            travel_time =int(para[5].replace("'",""))*60
        Result_Aggression = para[6].replace("'","")
        Output_layer = para[7].replace("'","")
        symbology_index = 7
        transpotations["type"] = Transportation_type
        Search_range_width= 0
    else :
        departure_search = para[0].replace("'","")
        Departure_ID = para[1].replace("'","")
        search_type = para[3].replace("'","")
        Time_zone = para[2].replace("'","")
        Date_time = dateutil.parser.parse(para[4].replace("'",""))    
        Transportation_type = para[5].replace("'","")
        
        if int(para[6]) > 240:
            arcpy.AddError("Travel time should be less than or equal to 240 mins , please try again with different time")
        else:
            travel_time =int(para[6].replace("'",""))*60
        Result_Aggression = para[7].replace("'","")
        Field_To_keep = para[8]
        Output_layer = para[9].replace("'","")
        symbology_index = 9
        change_delay = para[10].replace("'","")
        walking_time= para[11].replace("'","")
        driving_time_to_station= para[12].replace("'","")
        cycling_time_to_station= para[13].replace("'","")
        parking_time= para[14].replace("'","")
        boarding_time= para[15].replace("'","")
        Search_range_width= int(para[16].replace("'",""))*60

        transpotations["type"] = Transportation_type
        transpotations["pt_change_delay"] = int(change_delay)*60
        transpotations["walking_time"] = int(walking_time)*60
        transpotations["driving_time_to_station"] = int(driving_time_to_station)*60
        transpotations["cycling_time_to_station"] = int(cycling_time_to_station)*60
        transpotations["parking_time"] = int(parking_time)*60
        transpotations["boarding_time"] = int(boarding_time)*60
        

    #tzinfo = arcpy.time.TimeZoneInfo(Time_zone)
 
    #Depart_arriv_Time= Date_time.astimezone(tzinfo)

    tzinfo = pytz.timezone(Time_zone)    
    Depart_arriv_Time = (tzinfo.localize(Date_time)).isoformat()
    didList = []


    def loadJson(jsonResponse,feature):
        jsonResult = jsonResponse   #.json()        
        try:
            
            if Result_Aggression == "UNION":
               
                for Jresults in jsonResult['results']:            
                    if "unions" in Jresults["search_id"]: 
                        geom = list()
                        for loc in Jresults['shapes']:            
                            coord = list()
                            coordHoles = list()
                            for parts in loc['shell']:
                                geometry = [parts['lng'],parts['lat']]
                                coord.append(geometry)
                            for holesparts in loc['holes']:
                                coordHoles = list()
                                for parts in holesparts:
                                    geometry = [parts['lng'],parts['lat']]
                                    coordHoles.append(geometry)
                                geom.append(coordHoles)
                            geom.append(coord)
                        try:                        
                            feature.append({"type": "Feature","id": "destination","geometry": {"type": "Polygon","coordinates":geom},"properties": {}})                           
                        except :
                            arcpy.AddError("Error")
            elif Result_Aggression == "INTERSECTION":
                
                 for Jresults in jsonResult['results']:                    
                    if  "intersection" in Jresults["search_id"]:
                        geom = list()
                        for loc in Jresults['shapes']:            
                            coord = list()
                            coordHoles = list()
                            for parts in loc['shell']:
                                geometry = [parts['lng'],parts['lat']]
                                coord.append(geometry)
                            for holesparts in loc['holes']:
                                coordHoles = list()
                                for parts in holesparts:
                                    geometry = [parts['lng'],parts['lat']]
                                    coordHoles.append(geometry)
                                geom.append(coordHoles)
                            geom.append(coord)                        
                        try:
                            if not any(geom):
                                arcpy.AddMessage("No Intersections found.")                            
                            else:                                
                                feature.append({"type": "Feature","id": "destination","geometry": {"type": "Polygon","coordinates":geom},"properties": {}})                               
                        
                        except :
                            arcpy.AddMessage("No record found.")
            else :
                
                coord = list()
                coordHoles = list()

                for Jresults in jsonResult['results']:                              
                    geom = list()
                    for loc in Jresults['shapes']:            
                        coord = list()
                        coordHoles = list()
                        for parts in loc['shell']:
                            geometry = [parts['lng'],parts['lat']]
                            coord.append(geometry)
                        for holesparts in loc['holes']:
                            coordHoles = list()
                            for parts in holesparts:
                                geometry = [parts['lng'],parts['lat']]
                                coordHoles.append(geometry)
                            geom.append(coordHoles)
                        geom.append(coord)
                    
                    try:
                        arcpy.AddMessage("Appending Features")
                        feature.append({"type": "Feature","id": "destination","geometry": {"type": "Polygon","coordinates":geom},"properties": {"Index_id": Jresults["search_id"]}})                       
                    except :
                        arcpy.AddError("Result is empty.Please try again")

            return feature
        except KeyError:
            arcpy.AddError("Feature {}".format(jsonResult))  
            pass



    def parseRequest(requestParameter,APP_ID,API_KEY,customize_endpoint):
        index =uuid.uuid1()
        featureCollections = list()
       
        API_ENDPOINT = customize_endpoint+"/v4/time-map"
        headers = {
            'Accept': "application/json",
            'X-Application-Id': APP_ID,
            'X-Api-Key': API_KEY,
            'Content-Type': "application/json",
            'User-Agent' : "ArcGIS Pro v1.0"
            }
        feature = list()
        featureCollection = list()        
        for request in requestParameter:
             try : 
                req = urllib.request.Request(API_ENDPOINT, json.dumps(request).encode('utf-8'), headers = headers)
                context = ssl.create_default_context(cafile=certifi.where())
                arcpy.AddMessage(req)
                html = json.loads(urllib.request.urlopen(req,context=context).read().decode('utf-8')) 
             except urllib.error.URLError as e:  
                    es = sys.exc_info()[1]
                    API_RESPONSE = e.file
                    data = json.load(API_RESPONSE)
                    arcpy.AddWarning('An error occurred: {}'.format(data))
                    continue
             try:
                features = loadJson(html,feature)
             except Exception:
                 arcpy.AddWarning(format(data))
                 continue

        if not features:
            arcpy.AddError("Feature {}".format("No records found") )            
        else:
            featureCollection.append({"type":"FeatureCollection","features":features})  
            outputFilePath =  os.path.join(dataPath, 'output.json')
            with open(outputFilePath,'w') as f:
                json.dump(featureCollection[0], f)
            arcpy.env.overwriteOutput = True
            try:
                if Result_Aggression == "NORMAL":
                    createOutputLayer(outputFilePath, Output_layer);
                else:
                    createOutputLayer(outputFilePath, Output_layer + "1");
                    arcpy.Dissolve_management(Output_layer + "1", Output_layer,"OBJECTID")                    

                pointLyrPath = os.path.join(dataPath, 'TimeMapSymbol.lyrx')
                params = arcpy.GetParameterInfo()
                desc = arcpy.Describe(Output_layer)                
                params[symbology_index].symbology = pointLyrPath

                if Result_Aggression == "NORMAL":
                    layerName = (arcpy.Describe(Output_layer)).baseName
                    arcpy.AddMessage(layerName)

                feature = list()
                featureCollection = list()

                if Result_Aggression == "NORMAL":
                    if len(para) > 8:
                        arcpy.JoinField_management(layerName, "Index_id", departure_search,"Index_id",parametersList[8] )
                    
            except Exception as inst:
                arcpy.AddError(inst)            
                pass
           
    def createOutputLayer(path,name):
        results = arcpy.JSONToFeatures_conversion(path,name )
        arcpy.RepairGeometry_management(name)

    def createJson(APP_ID,API_KEY,customize_endpoint):

        arrival_searches=None
    
        departure_id =list()
        arrival_ids =list()
        deapartureSearch= list()
        arrivalSearch = list()
        departure_search_list = list()   
        ApiCount =0
        if len(para)>= 8:
            fields = arcpy.ListFields(departure_search)
            if fields[0].name == "FID":
                arcpy.AddMessage("Unique Fields Are not Matched.. We added the Unique ID field to map the fields.")
                arcpy.AddField_management(departure_search, "OBJECTID", "Long", "", "", "20")
                arcpy.CalculateField_management(departure_search, "OBJECTID","!FID!+1", "Python 3")
            code_block = \
'''rec=0
def SequentialNumber():
    global rec
    pStart = 1
    pInterval = 1
    if (rec == 0):
        rec = pStart
    else:
        rec = rec + pInterval
    return "Location"+str(rec)'''

            if fields[len(fields)-1].name == "Index_id":
                arcpy.CalculateField_management(departure_search, "Index_id","SequentialNumber()", "Python 3",code_block)
            else:
                try:   
                    arcpy.AddField_management(departure_search, "Index_id", "Text", "", "", "20")
                    arcpy.CalculateField_management(departure_search, "Index_id","SequentialNumber()", "Python 3",code_block)
                except Exception:
                    logger.error(format(data))
                    arcpy.AddError(format(data))

        for row in arcpy.da.SearchCursor(departure_search, ["Index_id", "SHAPE@"]):
       
            pnt_wgs = row[1].projectAs(wgs)
            id_search = str(row[0])
            arrival_ids.append(str(row[0]))
            departure_id.append(id_search)
            #arcpy.AddMessage(id_search)
            if search_type == "departure":
                if Search_range_width == 0:
                    deapartureSearch.append({"id":id_search,"coords" : { "lng" : pnt_wgs.centroid.X, "lat":pnt_wgs.centroid.Y },"transportation":transpotations,"departure_time": Depart_arriv_Time,"travel_time":travel_time})
                else:
                    deapartureSearch.append({"id":id_search,"coords" : { "lng" : pnt_wgs.centroid.X, "lat":pnt_wgs.centroid.Y },"transportation":transpotations,"departure_time": Depart_arriv_Time,"travel_time":travel_time,"range": {"enabled": True,"width": Search_range_width}})
            else:
                if Search_range_width == 0:
                    arrivalSearch.append({"id":id_search,"coords" : { "lng" : pnt_wgs.centroid.X, "lat":pnt_wgs.centroid.Y },"transportation":transpotations,"arrival_time": Depart_arriv_Time,"travel_time":travel_time})
                else:
                    arrivalSearch.append({"id":id_search,"coords" : { "lng" : pnt_wgs.centroid.X, "lat":pnt_wgs.centroid.Y },"transportation":transpotations,"arrival_time": Depart_arriv_Time,"travel_time":travel_time,"range": {"enabled": True,"width": Search_range_width}})
        d=1 
        union_chunk = [departure_id[i * d:(i + 1) * d] for i in range((len(departure_id) + d - 1) // d )] 
        union =list()
        for i in range(len(union_chunk)):
            union.append({"id":"unions"+str(i),"search_ids":union_chunk[i]})
    
        intersection =list()
        for i in range(len(union_chunk)):
            intersection.append({"id":"intersection"+str(i),"search_ids":union_chunk[i]})
   
        if search_type == "departure":
            departure_searches_chunk = list()
            departure_searches_chunk = [deapartureSearch[i * d:(i + 1) * d] for i in range((len(deapartureSearch) + d - 1) // d )] 
            i=0            
            departure_search_list = list() 
            for departure_searche in departure_searches_chunk:                
                searchids =list()
                searchids.append(union[i])
                intersection_searchids =list()
                intersection_searchids.append(intersection[i])
                if Result_Aggression == "UNION":
                    req =TimeMapParams(departure_searche,None,searchids,None)
                elif Result_Aggression == "INTERSECTION":
                    req =TimeMapParams(departure_searche,None,None,intersection_searchids)
                else:
                    req =TimeMapParams(departure_searche,None,None,None)
                i = i+1;      
                ApiCount = ApiCount+1
                departure_search_list.append(req.__dict__)
            parseRequest(departure_search_list,APP_ID,API_KEY,customize_endpoint)
        else:
            arrival_searches_chunk = [arrivalSearch[i * d:(i + 1) * d] for i in range((len(arrivalSearch) + d - 1) // d )] 
            i=0            
            departure_search_list = list() 
            for arrival_searche in arrival_searches_chunk:                
                searchids =list()
                searchids.append(union[i])
                intersection_searchids =list()
                intersection_searchids.append(intersection[i])
                if Result_Aggression == "UNION":
                    req =TimeMapParams(None,arrival_searche,searchids,None)
                elif Result_Aggression == "INTERSECTION":
                    req =TimeMapParams(None,arrival_searche,None,intersection_searchids)
                else:
                    req =TimeMapParams(None,arrival_searche,None,None)
                i = i+1;      
                ApiCount = ApiCount+1
                departure_search_list.append(req.__dict__)
            parseRequest(departure_search_list,APP_ID,API_KEY,customize_endpoint)
        arcpy.AddMessage("Due to the large amount of features, the request will be chunked in "+str(ApiCount)+" API calls. This may have unexpected consequences on some parameters. Keep an eye on your API usage !")

        departure_id =list()
        arrival_ids =list()
        deapartureSearch= list()
        arrivalSearch = list()
        departure_search_list = list()   

  ### authentication  starting point
    authenticatoinFilePath =  os.path.join(toolSharePath, 'Authentication.json')
    aprx = arcpy.mp.ArcGISProject("CURRENT")
   
    try:
        with open(authenticatoinFilePath) as f:
          arcpy.AddMessage("Checking authentication")  
          data = json.load(f)      
          if  '' in [data['Api_key'], data['App_id']]:
              arcpy.AddError("Error: You need a TravelTime platform API key to make requests. Please head to https://docs.traveltime.com/arcgis/sign-up to obtain one, and enter it in the plugin's setting dialog.")
              exit(0)
              #APP_ID = "d8e9df9d"
              #API_KEY = "8a062f21f574e7918700ff2feba8fa98"
              #createJson(APP_ID,API_KEY,customize_endpoint)
          else:
             APP_ID =  data['App_id']
             API_KEY = data['Api_key']
             customize_endpoint = data['customize_endpoint']
             createJson(APP_ID,API_KEY,customize_endpoint)
    except Exception:
        e = sys.exc_info()[1]
        logger.error(format(data))
        #logger.error('{},{},{}'.format(e.code,e.reason,es))
        #logger.debug('A debug message'.format(e.args[0]))
        #arcpy.AddError('An error occurred: {}'.format(e.args[0]))
        arcpy.AddError(format(data))
        exit(0)
    
