import logging
import logging.handlers
import arcpy
from arcpy import env
import requests
import logging
logging.basicConfig(level=logging.DEBUG)
r = requests.get('http://httpbin.org/get?foo=bar&baz=python')
class ArcPyLogHandler(logging.handlers.RotatingFileHandler):
    """
    Custom logging class that bounces messages to the arcpy tool window as well
    as reflecting back to the file.
    """

    def emit(self, record):
        """
        Write the log message
        """
        arcpy.AddMessage("I'm getting here")
        outputDir = arcpy.env.scratchFolder
       
        outputLogName = 'Logfile' + r".log"
        outputFileLog = os.path.join(outputDir, outputLogName)

        try:
            msg = record.msg.format(record.args)
        except:
            msg = record.msg

        if record.levelno >= logging.ERROR:
            arcpy.AddError(msg)
        elif record.levelno >= logging.WARNING:
            arcpy.AddWarning(msg)
        elif record.levelno >= logging.INFO:
            arcpy.AddMessage(msg)

        super(ArcPyLogHandler, self).emit(record)
